/* Program skeleton for Problem A (2x2 matrix inversion) */

#include <stdio.h>
#include <stdlib.h>
#include "stdmotif.h"

void button_pushed (Widget widget, XtPointer client_data, XtPointer call_data);

Widget mw[4];  /* text fields for matrix coefficients: 0,1,2,3 for a,b,c,d */


/************************* MAIN PROGRAM **************************/

int main (argc, argv)
  int argc;
  char *argv[];
{
  Widget        toplevel, manager, square, buttons, invert, quit;
  XtAppContext  app;
  XmString 	invertlabel, quitlabel;

  /*---------- 1. initialize X and Motif --------------------------------*/
  /* (already complete, should not be changed) */
  /*globalInitialize ("A");*/
  toplevel = XtVaAppInitialize (&app, "Hello", NULL, 0,
        &argc, argv, fallbacks, NULL);

  /*---------- 2. create and configure widgets --------------------------*/

  manager = XmCreateRowColumnManagerOCP ("manager", toplevel, XmVERTICAL,
                                         2, False);
  square = XmCreateRowColumnManagerOCP ("square", manager, XmHORIZONTAL,
                                        2, True);
  buttons = XmCreateRowColumnManagerOCP ("buttons", manager, XmHORIZONTAL,
                                         1, False);
  mw[0] = XmCreateTextFieldWidgetW ("aw", square, 100, "a");
  mw[1] = XmCreateTextFieldWidgetW ("bw", square, 100, "b");
  mw[2] = XmCreateTextFieldWidgetW ("cw", square, 100, "c");
  mw[3] = XmCreateTextFieldWidgetW ("dw", square, 100, "d");
  invert = XmCreatePushButtonL ("invert", buttons, 
                                XmStringCreateLocalized ("Invert matrix"));
  quit = XmCreatePushButtonL ("quit", buttons, 
                              XmStringCreateLocalized ("Quit"));

  /*---------- 3. register callback functions ---------------------------*/

  XtAddCallbackF (invert, XmCactivateCallback, button_pushed, (XtPointer)1);
  XtAddCallbackF (quit, XmCactivateCallback, button_pushed, (XtPointer)99);

  /*---------- 4. realize widgets and turn control to X event loop ------*/
  /* (already complete, should not be changed) */
  XtRealizeWidget (toplevel);
  XtAppMainLoop (app);
  return (0);
}

/************************* Functions *************************/

void button_pushed (Widget widget, XtPointer client_data, XtPointer call_data)
{
  /* dies ist die callback-Funktion, die bei Anklicken der PushButtons
     aufgerufen werden muss */
  double mat[4], new[4], det;
  String s;
  if ((int)client_data == 99) {
     exit (0);
  }
  else if ((int)client_data == 1) {
    int i;
    for (i = 0; i <= 3; i++) {
      XtGetStringValue (mw[i], XmCvalue, &s);
      mat[i] = atof (s);
    }
    det = mat[0]*mat[3] - mat[1]*mat[2];
    if (det != 0) {
      new[0] = mat[3]/det; new[1] = -mat[1]/det; 
      new[2] = -mat[2]/det; new[3] = mat[0]/det;
      for (i = 0; i <= 3; i++)
        XtSetStringValue (mw[i], XmCvalue, ftoa (new[i], 8, 2));
    }
    else
      matrixErrorMessage ("Matrix cannot be inverted", mat, 8, 2);
  }
}


